(function() {
plugins["reg"]={
    version:"v1.0.0",
    lastChange:"Nov 13st 2008",
    displayName:"reg",
    directory:currentDirectory,
    icon:currentDirectory+"\\reg.ico",
    aliasstr:"reg",
    //autocomplete:"colors", // replace the default completion : you need to define an alias file to use it
    search:function(querykey, explicit, queryraw, querynokeyword, modifier, triggermethod) {
        //displayBalloonMessage(queryraw);
        if(!explicit) return;
       
        //try {
        var HKEY_LOCAL_MACHINE = 0x80000002;
        var REG_SZ = 1;
        var REG_EXPAND_SZ = 2;
        var REG_BINARY = 3;
        var REG_DWORD = 4;
        var REG_MULTI_SZ = 7;

        var q1=queryraw.replace(/^reg /,"")
        var subkey=q1.substring(0, q1.lastIndexOf("\\"));
        var path=(subkey!=""?subkey+"\\":"");
        
        var reg=FARR.getObject("winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\default:StdRegProv");
        
        var enumKey=reg.Methods_.Item("EnumKey");
        var inParams = enumKey.InParameters.SpawnInstance_();
        inParams.hDefKey = HKEY_LOCAL_MACHINE;
        inParams.sSubKeyName = subkey;
        var outParams = reg.ExecMethod_(enumKey.Name, inParams);        
        
        try {
        var keys = outParams.sNames.toArray();
        for(var i=0;i<keys.length;i++) {
            FARR.emitResult(querykey,keys[i],"reg "+path+keys[i]+"\\", this.directory+"\\key.ico",UNKNOWN,MATCH_AGAINST_SEARCH,10000,inParams.sSubKeyName);
        }
        } catch(e) {}
        
        var enumValues=reg.Methods_.Item("EnumValues");
        var inParams = enumValues.InParameters.SpawnInstance_();
        inParams.hDefKey = HKEY_LOCAL_MACHINE;      
        inParams.sSubKeyName = subkey;
        var outParams = reg.ExecMethod_(enumValues.Name, inParams);
        
        try {
        var names = outParams.sNames.toArray();
        var types = outParams.Types.toArray();
        for(var i=0;i<names.length;i++) {
            FARR.emitResult(querykey,names[i],path+names[i], this.directory+"\\stringValue.ico",UNKNOWN,MATCH_AGAINST_SEARCH,10000,inParams.sSubKeyName);
        }
        } catch(e) {}
        
        
        var filter=q1;
        if(q1.lastIndexOf("\\")!=-1)
            filter=q1.substring(q1.lastIndexOf("\\")+1);
        
        forceResultFilter(filter);
        //displayBalloonMessage(filter);
        
        stopSearch();
        /*} catch(e) {
        }*/
    },
    trigger:function(path, title, groupname, pluginid, thispluginid, score, entrytype, args) {        
        //if(groupname!="fssc/colors") return;        
        if(path.indexOf("reg ")!=0) return;
        
        FARR.exec(this.directory+"\\regjump.exe", "HKLM\\"+path.substring(4),"");
        
        return HANDLED|CLOSE;
    },
    showSettings:function() {
        FARR.debug("showSettings");
        //FARR.exec(this.directory+"\\colorsSettings.ahk");
    }
}
})();